package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDState_hasActivity_SDActivity;

import java.util.SortedSet;
import java.util.TreeSet;

import javax.xml.bind.annotation.XmlTransient;

/**
 * @author Andrea Frasca
 */
public class SDActivity extends SDInnerComponent {
	
	@XmlTransient
	private SortedSet<SDState> states;
	
	protected SDActivity(){
		super();
	}
	
	protected SDActivity(String name){
		super(name);
		states = new TreeSet<SDState>();
	}
	
	public SortedSet<SDState> getStates() {
		return new TreeSet<SDState>(this.states);
	}

	protected void setStates(SortedSet<SDState> _states) {
		this.states = new TreeSet<SDState>(_states);
	}
	
	public void addState(SDState_hasActivity_SDActivity link)
		throws AssociationTargetException {
		if (!link.getActivity().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.states.add(link.getState());
	}

	public void removeState(SDState_hasActivity_SDActivity link)
		throws AssociationTargetException {
		if (!link.getActivity().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.states.remove(link.getState());
	}
}
