package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.NameIdentifiable;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasCondition_SDCondition;

import java.util.SortedSet;
import java.util.TreeSet;

import javax.xml.bind.annotation.XmlTransient;

/**
 * @author Andrea Frasca
 */
public class SDCondition extends SDInnerComponent {
	
	public static final String DEFAULT_IDENTIFIER_NAME_INFIX = "condition";
	
	@XmlTransient
	private SortedSet<SDTransition> transitions;
	
	protected SDCondition(){
		super();
	}
	
	protected SDCondition(String name){
		super(name);
		transitions = new TreeSet<SDTransition>();
	}
	
	public SortedSet<SDTransition> getTransitions() {
		return new TreeSet<SDTransition>(this.transitions);
	}

	protected void setTransition(SortedSet<SDTransition> _transitions) {
		this.transitions = new TreeSet<SDTransition>(_transitions);
	}
	
	public void addTransition(SDTransition_hasCondition_SDCondition link)
		throws AssociationTargetException {
		if (!link.getCondition().equals(this))
			throw new AssociationTargetException(
				link.getClass().getName(),
				this.getClass().getName());
		this.transitions.add(link.getTransition());
	}

	public void removeTransition(SDTransition_hasCondition_SDCondition link)
		throws AssociationTargetException {
		if (!link.getCondition().equals(this))
			throw new AssociationTargetException(
				link.getClass().getName(),
				this.getClass().getName());
		this.transitions.remove(link.getTransition());	
	}
	
	@Override
	public String getIdentifierName() {
		return
			this.getDiagram().getName() +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			DEFAULT_IDENTIFIER_NAME_INFIX+
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			this.getName();
	}

}
