package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDDiagram_isComposedBy_SDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasCondition_SDCondition;

/**
 * @author Andrea Frasca
 */
public class SDCondition_Factory {
	
	public SDCondition condition;
	
	public SDCondition createInstance(SDDiagram diagram, SDTransition transition){
		this.condition = new SDCondition();
		this.resolveLinkConstraints(diagram, transition);
		return this.condition;
	}
	
	public SDCondition createInstance(SDDiagram diagram, SDTransition transition, String name){
		this.condition = new SDCondition(name);
		this.resolveLinkConstraints(diagram, transition);
		return this.condition;
	}
	
	private void resolveLinkConstraints(SDDiagram diagram, SDTransition transition) {
		SDDiagram_isComposedBy_SDElement.addLink(
				diagram, this.condition);
		SDTransition_hasCondition_SDCondition.addLink(
				transition, this.condition);
	}
}
