package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.NameIdentifiable;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasAction_SDAction;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasCondition_SDCondition;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasDestination_SDState;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasEvent_SDEvent;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasOrigin_SDState;

/**
 * @author Andrea Frasca
 */
public class SDTransition extends SDComponent {
	
	public static final String DEFAULT_IDENTIFIER_NAME_INFIX = "transition";
	
	private SDEvent event;
	private SDCondition condition;
	private SDAction action;
	private SDState origin;
	private SDState destination;
	
	protected SDTransition(){
		super();
	}
	
	protected SDTransition(String name){
		super(name);
	}
	
	public SDEvent getEvent() {
		return this.event;
	}

	protected void setEvent(SDEvent event) {
		this.event = event;
	}
	
	public SDCondition getCondition() {
		return this.condition;
	}

	protected void setCondition(SDCondition condition) {
		this.condition = condition;
	}
	
	public SDAction getAction() {
		return this.action;
	}

	protected void setAction(SDAction action) {
		this.action = action;
	}
	
	public SDState getOrigin() {
		return this.origin;
	}

	protected void setOrigin(SDState origin) {
		this.origin = origin;
	}
	
	public SDState getDestination() {
		return this.destination;
	}

	protected void setDestination(SDState destination) {
		this.destination = destination;
	}
	
	public void setEvent(SDTransition_hasEvent_SDEvent link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setEvent(link.getEvent());
	}

	public void unsetEvent(SDTransition_hasEvent_SDEvent link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.event = null;
	}
	
	public void setCondition(SDTransition_hasCondition_SDCondition link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setCondition(link.getCondition());
	}

	public void unsetCondition(SDTransition_hasCondition_SDCondition link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.condition = null;
	}
	
	public void setAction(SDTransition_hasAction_SDAction link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setAction(link.getAction());
	}

	public void unsetAction(SDTransition_hasAction_SDAction link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.action = null;
	}
	
	public void setOrigin(SDTransition_hasOrigin_SDState link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setOrigin(link.getState());
	}

	public void unsetOrigin(SDTransition_hasOrigin_SDState link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.origin = null;
	}
	
	public void setDestination(SDTransition_hasDestination_SDState link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setDestination(link.getState());
	}

	public void unsetDestination(SDTransition_hasDestination_SDState link)
	throws AssociationTargetException {
		if (!link.getTransition().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.destination = null;
	}
	
	@Override
	public String getIdentifierName() {
		return
			this.getDiagram().getName() +
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			DEFAULT_IDENTIFIER_NAME_INFIX+
			NameIdentifiable.IDENTIFIER_NAME_SEPARATOR +
			this.getName();
	}
}
