package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDMacroState;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDState;

/**
 * @author Andrea Frasca
 */
public class SDMacroState_containsInitState_SDState {
	

	private SDMacroState macroState;
	private SDState state;
	
	private SDMacroState_containsInitState_SDState (
			SDMacroState macroState, SDState state) {
		this.state = state;
		this.macroState = macroState;
	}

	public static void addLink(
			SDMacroState macroState, SDState state) {
		
		//evita il fatto che un macrostato possa contenere se stesso
		if(!macroState.equals(state)){
		
			SDMacroState_containsInitState_SDState self =
			new SDMacroState_containsInitState_SDState(
					macroState, state);
			state.addMacroStateWhoIsInit(self);
			macroState.setInitState(self);
		}
	}

	public static void removeLink(
			SDMacroState macroState, SDState state) {
		SDMacroState_containsInitState_SDState self =
			new SDMacroState_containsInitState_SDState(
					macroState, state);
			state.removeMacroStateWhoIsInit(self);
			macroState.unsetInitState(self);
	}

	public SDState getState() {
		return this.state;
	}

	public SDMacroState getMacroState() {
		return this.macroState;
	}
	
}
