package it.uniroma1.dis.mfis.redia.verifint.test;

import it.uniroma1.dis.mfis.redia.verifint.control.ExecutionProperties;
import it.uniroma1.dis.mfis.redia.verifint.control._dataTypes.ProvingResult;
import it.uniroma1.dis.mfis.redia.verifint.control.io.XmlMarshaller;
import it.uniroma1.dis.mfis.redia.verifint.control.provers._constants.NuSMVConstants;
import it.uniroma1.dis.mfis.redia.verifint.control.provers.analysis.stateDiagram.SDNuSMVProver;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDAction;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDAction_Factory;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDCondition_Factory;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDDiagram;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDEvent;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDEvent_Factory;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDMacroState;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDMacroState_Factory;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDState;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDState_Factory;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDTransition;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDTransition_Factory;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDMacroState_contains_SDState;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasEvent_SDEvent;

import java.io.FileReader;
import java.io.StringReader;
import java.io.StringWriter;

import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

/**
 * @author Andrea Frasca
 */
public class SDTest {
	
	public static void main(String[] args){
		prove();	
	}
	
	private static void prove(){
		
		// prepare the diagram to test
		SDDiagram testDiagram = contentoScontentoDiagram();
        String testFormula = "G(state=contento) ";
		
		//SDDiagram testDiagram = buildClienteDiagram();
        //UN CLIENTE IN RITARDO ANCHE SOLO UNA VOLTA NON SAR`A MAI PI`U AFFIDABILE 
		//String testFormula = "G(F event = in_ritardo -> F G state != affidabile) ";
		
		//SDDiagram testDiagram = buildProfessoreDiagram();
		//DALLANNO SABBATICO NON SI PU`O ANDARE DIRETTAMENTE IN FERIE. 
		//String testFormula = "G (state = anno_sabbatico -> X state != ferie) ";
		
		//SDDiagram testDiagram = buildComplexModemDiagram();
		//String testFormula = "G (state = ripristino & X(event) = complete -> X X(state) = attesa) ";
		
		
		// marshal the given diagram in XML
		String xmlString = new XmlMarshaller().marshal(testDiagram);
		
		
		
		// from now on, the print the results
		System.out.println("\n" +
				"########################################" + "\n" +
				"####   XML:                            #" + "\n" +
				"########################################" + "\n"
		);
		System.out.println(xmlString);
		
		System.out.println("\n" +
				"########################################" + "\n" +
				"####   AFTER XSLT PROCESSING:          #" + "\n" +
				"########################################" + "\n"
		);
		// proving
		ProvingResult result = new SDNuSMVProver(testDiagram).prove(testFormula);
		
		
		// from now on, the print the results
		
		System.out.println("\n" +
				"########################################" + "\n" +
				"####   Given the formula:              #" + "\n" +
				"########################################" + "\n"
		);
		System.out.println(testFormula);
		/*System.out.println("\n" +
				"########################################" + "\n" +
				"####   The formula is:                 #" + "\n" +
				"########################################" + "\n"
		);
		System.out.println(proof.proven);*/
		System.out.println("\n" +
				"########################################" + "\n" +
				"####   The NuSMV response is:          #" + "\n" +
				"########################################" + "\n"
		);
		System.out.println(result.proof);
		
	}
	
	
	private static SDDiagram buildComplexModemDiagram(){
		
		SDDiagram diagram = new SDDiagram("complex_modem_Diagram");
		
		SDState_Factory state_factory = new SDState_Factory();
		SDAction_Factory action_factory = new SDAction_Factory();
		SDEvent_Factory event_factory = new SDEvent_Factory();
		SDTransition_Factory transition_factory = new SDTransition_Factory();
		SDMacroState_Factory macrostate_factory = new SDMacroState_Factory();
		SDCondition_Factory condition_factory = new SDCondition_Factory();
		
		// definisco gli stati
		SDState spento = state_factory.createInstance(diagram, "spento");
		SDState attesa = state_factory.createInstance(diagram, "attesa");
		SDState connesso = state_factory.createInstance(diagram, "connesso");
		SDState ripristino = state_factory.createInstance(diagram, "ripristino");
		SDState reimpostato = state_factory.createInstance(diagram, "reimpostato");
		spento.setInit();
		
		SDMacroState normal = macrostate_factory.createInstance(diagram, attesa, "normal");
		SDMacroState recovery = macrostate_factory.createInstance(diagram, ripristino, "recovery");
		SDMacroState_contains_SDState.addLink(normal,connesso);
		SDMacroState_contains_SDState.addLink(recovery, reimpostato);
		
		//SDMacroState_containsInitState_SDState.addLink(recovery, reimpostato);
		
		// definisco le transizioni
		SDTransition spento_to_normal = transition_factory.createInstance(diagram, spento, normal, "spento_to_normal");
		SDTransition normal_to_spento = transition_factory.createInstance(diagram, normal, spento,"normal_to_spento");
		
		SDEvent on = event_factory.createInstance(diagram, spento_to_normal, "on");
		SDEvent off = event_factory.createInstance(diagram, normal_to_spento, "off");
		
		SDTransition attesa_to_connesso = transition_factory.createInstance(diagram, attesa, connesso, "attesa_to_connesso");
		SDTransition connesso_to_attesa = transition_factory.createInstance(diagram, connesso, attesa, "connesso_to_attesa");
		
		SDEvent composizione = event_factory.createInstance(diagram, attesa_to_connesso, "composizione");
		SDEvent scollega = event_factory.createInstance(diagram, connesso_to_attesa, "scollega");
		
		SDTransition normal_to_recovery = transition_factory.createInstance(diagram, normal, recovery, "normal_to_recovery");
		SDEvent reset = event_factory.createInstance(diagram, normal_to_recovery, "reset");
		
		SDTransition ripristino_to_reimpostato = transition_factory.createInstance(diagram, ripristino, reimpostato, "ripristino_to_reimpostato");
		SDEvent restart = event_factory.createInstance(diagram, ripristino_to_reimpostato, "restart");
		
		SDTransition reimpostato_to_attesa = transition_factory.createInstance(diagram, reimpostato, attesa, "reimpotato_to_attesa");
		SDEvent complete  = event_factory.createInstance(diagram, reimpostato_to_attesa, "complete");
		
		return diagram;
	}
	
	private static SDDiagram buildProfessoreDiagram(){
		
		SDDiagram diagram = new SDDiagram("impiegato_Diagram");
		
		SDState_Factory state_factory = new SDState_Factory();
		SDAction_Factory action_factory = new SDAction_Factory();
		SDEvent_Factory event_factory = new SDEvent_Factory();
		SDTransition_Factory transition_factory = new SDTransition_Factory();
		SDMacroState_Factory macrostate_factory = new SDMacroState_Factory();
		SDCondition_Factory condition_factory = new SDCondition_Factory();
		
		// definisco gli stati
		SDState in_servizio = state_factory.createInstance(diagram, "in_servizio");
		SDState ferie = state_factory.createInstance(diagram, "ferie");
		SDState malattia = state_factory.createInstance(diagram, "malattia");
		SDState anno_sabbatico = state_factory.createInstance(diagram, "anno_sabbatico");
		in_servizio.setInit();
		
		// definisco le transizioni
		SDTransition in_servizio_to_ferie = transition_factory.createInstance(diagram, in_servizio, ferie, "in_servizio_to_ferie");
		SDTransition in_servizio_to_malattia = transition_factory.createInstance(diagram, in_servizio, malattia, "in_servizio_to_malattia");
		SDTransition in_servizio_to_anno_sabbatico = transition_factory.createInstance(diagram, in_servizio, anno_sabbatico, "in_servizio_to_anno_sabbatico");
		SDTransition ferie_to_malattia = transition_factory.createInstance(diagram, ferie, malattia, "ferie_to_malattia");
		SDTransition malattia_to_anno_sabbatico = transition_factory.createInstance(diagram, malattia, anno_sabbatico, "malattia_to_anno_sabbatico");
		
		SDEvent in_ferie = event_factory.createInstance(diagram, in_servizio_to_ferie, "in_ferie");
		SDEvent in_malattia = event_factory.createInstance(diagram, in_servizio_to_malattia, "in_malattia");
		SDEvent in_anno_sabbatico = event_factory.createInstance(diagram, in_servizio_to_anno_sabbatico, "in_anno_sabbatico");
		SDTransition_hasEvent_SDEvent.addLink(ferie_to_malattia, in_malattia);
		SDTransition_hasEvent_SDEvent.addLink(malattia_to_anno_sabbatico, in_anno_sabbatico);
		
		SDMacroState assente = macrostate_factory.createInstance(diagram, ferie, "assente");
		
	    SDMacroState_contains_SDState.addLink(assente, ferie);
		SDMacroState_contains_SDState.addLink(assente, malattia);
		SDMacroState_contains_SDState.addLink(assente, anno_sabbatico);
		
	
		SDTransition assente_to_in_servizio = transition_factory.createInstance(diagram, assente, in_servizio, "assente_to_in_servizio");
		//SDEvent rientro = event_factory.createInstanceWhenMacroStateIsInit(diagram, assente_to_in_servizio, "rientro");
		SDEvent rientro = event_factory.createInstance(diagram, assente_to_in_servizio, "rientro");
		
		
		return diagram;
	}
	
	private static SDDiagram contentoScontentoDiagram(){
		SDDiagram diagram = new SDDiagram("cliente_Diagram");
		
		SDState_Factory state_factory = new SDState_Factory();
		SDAction_Factory action_factory = new SDAction_Factory();
		SDEvent_Factory event_factory = new SDEvent_Factory();
		SDTransition_Factory transition_factory = new SDTransition_Factory();
		SDMacroState_Factory macrostate_factory = new SDMacroState_Factory();
		SDCondition_Factory condition_factory = new SDCondition_Factory();
		
		// definisco gli stati
		SDState contento = state_factory.createInstance(diagram, "contento");
		SDState scontento = state_factory.createInstance(diagram, "scontento");
		SDTransition contento_to_scontento = transition_factory.createInstance(diagram, contento, scontento, "contento_to_scontento");
		SDEvent evento = event_factory.createInstance(diagram, contento_to_scontento, "buio");
		SDAction action = action_factory.createInstance(diagram, contento_to_scontento ,"abbassa");
		SDAction action2 = action_factory.createInstance(diagram, contento_to_scontento ,"alza");
		return diagram;
	}
	private static SDDiagram buildClienteDiagram(){
		
		SDDiagram diagram = new SDDiagram("cliente_Diagram");
		
		SDState_Factory state_factory = new SDState_Factory();
		SDAction_Factory action_factory = new SDAction_Factory();
		SDEvent_Factory event_factory = new SDEvent_Factory();
		SDTransition_Factory transition_factory = new SDTransition_Factory();
		SDMacroState_Factory macrostate_factory = new SDMacroState_Factory();
		SDCondition_Factory condition_factory = new SDCondition_Factory();
		
		// definisco gli stati
		SDState nuovo = state_factory.createInstance(diagram, "nuovo");
		SDState affidabile = state_factory.createInstance(diagram, "affidabile");
		SDState moroso = state_factory.createInstance(diagram, "moroso");
		SDState sospetto = state_factory.createInstance(diagram, "sospetto");
		nuovo.setInit();
		
		// definisco le transizioni
		SDTransition nuovo_to_affidabile = transition_factory.createInstance(diagram, nuovo, affidabile, "nuovo_to_affidabile");
		SDTransition nuovo_to_moroso = transition_factory.createInstance(diagram, nuovo, moroso, "nuovo_to_moroso");
		SDTransition affidabile_to_moroso = transition_factory.createInstance(diagram, affidabile, moroso, "affidabile_to_moroso");
		SDTransition affidabile_to_affidabile = transition_factory.createInstance(diagram, affidabile, affidabile, "affidabile_to_moroso");
		SDTransition moroso_to_sospetto = transition_factory.createInstance(diagram, moroso, sospetto, "moroso_to_sospetto");
		SDTransition sospetto_to_moroso = transition_factory.createInstance(diagram, sospetto, moroso, "sospetto_to_moroso");
		SDTransition sospetto_to_sospetto = transition_factory.createInstance(diagram, sospetto, sospetto, "sospetto_to_sospetto");
		
		SDEvent paga = event_factory.createInstance(diagram, nuovo_to_affidabile, "paga");
		SDEvent in_ritardo = event_factory.createInstance(diagram, nuovo_to_moroso, "in_ritardo");
		SDTransition_hasEvent_SDEvent.addLink(affidabile_to_moroso, in_ritardo);
		SDTransition_hasEvent_SDEvent.addLink(affidabile_to_affidabile, paga);
		SDTransition_hasEvent_SDEvent.addLink(moroso_to_sospetto, paga);
		SDTransition_hasEvent_SDEvent.addLink(sospetto_to_moroso, in_ritardo);
		SDTransition_hasEvent_SDEvent.addLink(sospetto_to_sospetto, paga);
		
		return diagram;
	}
	
	private static void test(String xml) throws Exception {
		
		Source xmlSource = new StreamSource(new StringReader(xml));
		Source xsltSource = new StreamSource(
				new FileReader(
						System.getProperty("user.dir") + "/" +
						ExecutionProperties.getInstance().getProperty(
								NuSMVConstants.NUSMV_XSLT_PATH_KEY
							)
					)
			);
		
		TransformerFactory transFactory = TransformerFactory.newInstance();
		Transformer trans = transFactory.newTransformer(xsltSource);
		StringWriter newXmlWriter = new StringWriter();
		trans.transform(xmlSource, new StreamResult(newXmlWriter));
		
		String[] lines = newXmlWriter.toString().split("\\n");
		StringBuffer stringBuffer = new StringBuffer();
		for(String line : lines) {
			line = line.trim();
			if (!line.equals("")) {
				stringBuffer.append(line + "\n");
			}
		}
		
		System.out.println(stringBuffer.toString());
	}
	
}
