
package it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine;
/*
 * ControlPanel.java
 *
 * Created on 19 novembre 2008, 15.54
 */
import it.uniroma1.dis.mfis.redia.verifint.control.binding.StateDiagramBinder;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 *
 * @author  Gianluca pc
 */

class MenuListener implements ActionListener{
    ControlPanel panel;
    public MenuListener(ControlPanel p){
        panel = p;
    }
    public void actionPerformed(ActionEvent evt){
    	
    	if(evt.getActionCommand().equals("setInit")){
    		LinkedList fig = panel.getFigure();
            for(int i = 0; i < fig.size(); i++){
            	Object o = fig.get(i);
            	if(o instanceof StateFrame){
            		StateFrame sf = (StateFrame)o;
            		if(sf.getSelected()){
            			if(!sf.isInitial()) {
            				sf.setInitial();
            				panel.binder.setInitState(((Label)sf.getFigure().get(0)).getText());
            			}
            		} else sf.unsetInitial();
            		sf.setSelected(false);
            	}
            }
    	}
    	
       	if(evt.getActionCommand().equals("DeleteEdge")){
       		LinkedList fig = panel.getFigure();
            for(int i = 0; i < fig.size(); i++){
            if(fig.get(i) instanceof EdgeLoop){
            	EdgeLoop e = (EdgeLoop)fig.get(i);
            		if(e.getSelected()){
            			//e.getHead().getisHead().remove(e);
           				//e.getTail().getisTail().remove(e);
            			e.getHead().remove(e);
            			e.getTail().remove(e);
            			
            			panel.getFigure().remove(e);
            			
            			String edgeString = e.labelName.getText();
            			
            			String eventString = null;
            			if(edgeString.contains(" ")){
            				eventString = edgeString.substring(0, edgeString.indexOf(" "));
            			}else{
            				eventString = edgeString;
            			}
            			
            			String condString = null;
            			if(edgeString.contains("[")){
            				condString = edgeString.substring(edgeString.indexOf("["), edgeString.indexOf("]"));
            				condString = condString.substring(1, condString.indexOf("."));
            			}
            			
            			String result = null;
            			if(condString!=null){
            				result = eventString+condString;
            			}else{
            				result = eventString;
            			}
            			
            			//panel.binder.deleteElement(((Label)e.getTail().getFigure().get(0)).getText() + ((Label)e.getTail().getFigure().get(0)).getText() + eventString);
            			panel.binder.deleteElement(((Label)e.getTail().getFigure().get(0)).getText() + result);
            			
            			}
            } else
      		if(fig.get(i) instanceof EdgeST){
        		EdgeST e = (EdgeST)fig.get(i);
        		if(e.getSelected()){
       				e.getHead().getisHead().remove(e);
       				e.getTail().getisTail().remove(e);
        			
        			panel.getFigure().remove(e);
        			//System.out.println(((Label)e.getTail().getFigure().get(0)).getText() + ((Label)e.getHead().getFigure().get(0)).getText() + e.labelName.getText());
        			
        			String edgeString = e.labelName.getText();
        			
        			String eventString = null;
        			if(edgeString.contains(" ")){
        				eventString = edgeString.substring(0, edgeString.indexOf(" "));
        			}else{
        				eventString = edgeString;
        			}
        			
        			String condString = null;
        			if(edgeString.contains("[")){
        				condString = edgeString.substring(edgeString.indexOf("["), edgeString.indexOf("]"));
        				condString = condString.substring(1, condString.indexOf("."));
        			}
        			String result = null;
        			if(condString!=null){
        				result = eventString+condString;
        			}else{
        				result = eventString;
        			}
        			
        			//panel.binder.deleteElement(((Label)e.getTail().getFigure().get(0)).getText() + ((Label)e.getHead().getFigure().get(0)).getText() + eventString);
        			panel.binder.deleteElement(((Label)e.getTail().getFigure().get(0)).getText() + result);			
        			}
      			}
        	}
        }
       	
       	
        if(evt.getActionCommand().equals("Delete")){
            LinkedList fig = panel.getFigure();
            for(int i = 0; i < fig.size(); i++){
                if(fig.get(i) instanceof StateFrame){
                	StateFrame sf = (StateFrame)fig.get(i);
                if(sf.getSelected()) {
                	if(!sf.isInitial()){
                   panel.getFigure().remove(i);
                   Iterator lit = sf.getisTail().iterator();
                   while(lit.hasNext()){
                	   	  Object o = lit.next();
                	      if(o instanceof EdgeST){
                	   	  EdgeST e = (EdgeST)o;
                	   	  e.getHead().getisHead().remove(e);
                	      }
	                  	  panel.getFigure().remove(o);
                	      
                	
                    }
                   Iterator lit2 = sf.getisHead().iterator();
                   while(lit2.hasNext()){
                        Object o = lit2.next();
                	   	if(o instanceof EdgeST){
              	    	  EdgeST e = (EdgeST)o;
              	    	  e.getTail().getisTail().remove(e);
              	  
                	   	} 
	                	  panel.getFigure().remove(o);
                	 
                   }
                   
                   panel.binder.deleteElement(((Label)sf.getFigure().get(0)).getText());
                } else {
                	JOptionPane.showMessageDialog(panel,"Uno stato iniziale non pu essere eliminato","Attenzione",JOptionPane.WARNING_MESSAGE);
                	sf.setSelected(false);
                }
                }
                }
                
                }
            
        } else 
        if(evt.getActionCommand().equals("Move")){
           panel.setMove(true);
        } else
        if(evt.getActionCommand().equals("Prove")){
        	//binder
        	//System.out.println((panel.binder.prove(panel.ltlSpecTextField.getText()).proof));
        	//output
 
        	if(panel.ltlSpecTextField.getText().length() != 0){
        	
        	JFrame response = new JFrame("Prover response");
        	response.setSize(600, 600);
        	
        	response.setAlwaysOnTop(true);
        	
        	JTextArea textarea = new JTextArea();
        	textarea.setEditable(false);
            textarea.append(panel.binder.prove(panel.ltlSpecTextField.getText()).proof);
        	
            JScrollPane p = new JScrollPane(textarea);
            response.add(p);
            response.setVisible(true);
        } else JOptionPane.showMessageDialog(panel,"Inserire una specifica da verificare","Attenzione",JOptionPane.ERROR_MESSAGE);
        }
        panel.repaint();
    }
}

public class ControlPanel extends javax.swing.JFrame {
    boolean select = false;
    boolean drawing = false;
    boolean moving = false;
    boolean mod = false;
    protected StateDiagramBinder binder;
    private LinkedList ogg = new LinkedList();
    private LinkedList toDraw = new LinkedList();
    
    int xIniz, yIniz, xFin, yFin, xPressed, yPressed;
    JPopupMenu modify = new JPopupMenu();
    JPopupMenu deleteEdge = new JPopupMenu();
    JMenuItem delEdgeItem = new JMenuItem("Delete");
    JMenuItem delItem = new JMenuItem("Delete");
    JMenuItem moveItem = new JMenuItem("Move");
    JMenuItem initialItem = new JMenuItem("setInitial");
    MenuListener ml = new MenuListener(this);
    DefaultListModel dlmEvents = new DefaultListModel();
    DefaultListModel dlmActions = new DefaultListModel();
    DefaultListModel dlmConditions = new DefaultListModel();
    
    /** Creates new form ControlPanel */
    public ControlPanel(StateDiagramBinder b) {
        initComponents();
        binder = b;
        modify.add(delItem);
        modify.add(moveItem);
        modify.add(initialItem);
        delEdgeItem.addActionListener(ml);
        delEdgeItem.setActionCommand("DeleteEdge");
        deleteEdge.add(delEdgeItem);
        delItem.addActionListener(ml);
        delItem.setActionCommand("Delete");
        moveItem.addActionListener(ml);
        moveItem.setActionCommand("Move");
        initialItem.addActionListener(ml);
        initialItem.setActionCommand("setInit");
        eventsList.setModel(dlmEvents);
        actionsList.setModel(dlmActions);
        conditionsList.setModel(dlmConditions);
        doneMSButton.setVisible(false);
        proveButton.addActionListener(ml);
        proveButton.setActionCommand("Prove");
        this.setSize(850,650);
        this.setResizable(false);
    }
    
    public void setMove(boolean b){
        moving = b;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
   
//  <editor-fold defaultstate="collapsed" desc=" Generated Code ">
    private void initComponents() {
        InsertGroup = new javax.swing.ButtonGroup();
        HeadLabel = new javax.swing.JLabel();
        STPanel = new javax.swing.JPanel();
        modifyRB = new javax.swing.JRadioButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        eventsList = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        actionsList = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        conditionsList = new javax.swing.JList();
        addEventsButton = new javax.swing.JButton();
        eventsTextField = new javax.swing.JTextField();
        addActionsButton = new javax.swing.JButton();
        addConditionsButton = new javax.swing.JButton();
        actionTextField = new javax.swing.JTextField();
        conditionTextField = new javax.swing.JTextField();
        ltlLabel = new javax.swing.JLabel();
        ltlSpecTextField = new javax.swing.JTextField();
        proveButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        StateRB = new javax.swing.JRadioButton();
        NameLabel = new javax.swing.JLabel();
        ElementTextName = new javax.swing.JTextField();
        doneMSButton = new javax.swing.JButton();
        macroStateRB = new javax.swing.JRadioButton();
        EdgeRB = new javax.swing.JRadioButton();
        
        // disabilitato per il momento
        macroStateRB.setVisible(false);
        
        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("STATE TRANSITION DIAGRAM EDITOR & PROVER");
        setAlwaysOnTop(true);
        setBounds(new java.awt.Rectangle(0, 0, 640, 400));
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                formMousePressed(evt);
            }
        });

        HeadLabel.setFont(new java.awt.Font("Arial", 1, 14));
        HeadLabel.setText("State Transition Diagram Control Panel");
        getContentPane().add(HeadLabel);
        HeadLabel.setBounds(10, 10, 270, 17);

        STPanel.setLayout(null);

        STPanel.setBackground(new java.awt.Color(255, 255, 255));
        STPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        STPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                STPanelMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                STPanelMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                STPanelMouseReleased(evt);
            }
        });
        STPanel.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                STPanelMouseMoved(evt);
            }
        });

        getContentPane().add(STPanel);
        STPanel.setBounds(220, 30, 600, 400);

        InsertGroup.add(modifyRB);
        modifyRB.setSelected(true);
        modifyRB.setText("ModifySTDiagram");
        modifyRB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        modifyRB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        modifyRB.setName("modifyRB");
        getContentPane().add(modifyRB);
        modifyRB.setBounds(710, 0, 120, 20);

        jScrollPane1.setViewportView(eventsList);

        getContentPane().add(jScrollPane1);
        jScrollPane1.setBounds(20, 490, 250, 80);

        jLabel1.setText("Events");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(20, 440, 70, 14);

        jLabel2.setText("Actions");
        getContentPane().add(jLabel2);
        jLabel2.setBounds(280, 440, 100, 14);

        jScrollPane2.setViewportView(actionsList);

        getContentPane().add(jScrollPane2);
        jScrollPane2.setBounds(280, 490, 260, 80);

        jLabel3.setText("Conditions");
        getContentPane().add(jLabel3);
        jLabel3.setBounds(550, 440, 100, 14);

        jScrollPane3.setViewportView(conditionsList);

        getContentPane().add(jScrollPane3);
        jScrollPane3.setBounds(550, 490, 258, 80);

        addEventsButton.setText("Add");
        addEventsButton.setActionCommand("AddEvent");
        addEventsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addItemList(evt);
            }
        });

        getContentPane().add(addEventsButton);
        addEventsButton.setBounds(200, 460, 70, 23);

        getContentPane().add(eventsTextField);
        eventsTextField.setBounds(20, 460, 170, 20);

        addActionsButton.setText("Add");
        addActionsButton.setActionCommand("AddAction");
        addActionsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addItemList(evt);
            }
        });

        getContentPane().add(addActionsButton);
        addActionsButton.setBounds(470, 460, 70, 23);

        addConditionsButton.setText("Add");
        addConditionsButton.setActionCommand("AddCondition");
        addConditionsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addItemList(evt);
            }
        });

        getContentPane().add(addConditionsButton);
        addConditionsButton.setBounds(740, 460, 70, 23);

        getContentPane().add(actionTextField);
        actionTextField.setBounds(280, 460, 180, 20);

        getContentPane().add(conditionTextField);
        conditionTextField.setBounds(550, 460, 180, 20);

        ltlLabel.setText("LTL SPEC");
        getContentPane().add(ltlLabel);
        ltlLabel.setBounds(10, 290, 90, 14);

        getContentPane().add(ltlSpecTextField);
        ltlSpecTextField.setBounds(10, 330, 190, 20);

        proveButton.setText("Prove");
        getContentPane().add(proveButton);
        proveButton.setBounds(121, 370, 80, 23);

        jPanel1.setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("State Management"));
        InsertGroup.add(StateRB);
        StateRB.setText("State");
        StateRB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        StateRB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(StateRB);
        StateRB.setBounds(10, 40, 60, 15);

        NameLabel.setFont(new java.awt.Font("Arial", 0, 12));
        NameLabel.setText("State Name");
        jPanel1.add(NameLabel);
        NameLabel.setBounds(120, 20, 65, 15);

        jPanel1.add(ElementTextName);
        ElementTextName.setBounds(70, 40, 120, 20);

        doneMSButton.setText("Done");
        doneMSButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                macroButtonActionPerformed(evt);
            }
        });

        jPanel1.add(doneMSButton);
        doneMSButton.setBounds(110, 70, 80, 20);

        InsertGroup.add(macroStateRB);
        macroStateRB.setText("MacroState");
        macroStateRB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        macroStateRB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(macroStateRB);
        macroStateRB.setBounds(10, 70, 165, 15);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(10, 70, 200, 100);

        InsertGroup.add(EdgeRB);
        EdgeRB.setText("Transition");
        EdgeRB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        EdgeRB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        getContentPane().add(EdgeRB);
        EdgeRB.setBounds(20, 210, 90, 15);

        pack();
    }// </editor-fold>
    
    
  /*  private void initComponents() {
        InsertGroup = new javax.swing.ButtonGroup();
        STPanel = new javax.swing.JPanel();
        HeadLabel = new javax.swing.JLabel();
        modifyRB = new javax.swing.JRadioButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        eventsList = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        actionsList = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        conditionsList = new javax.swing.JList();
        addEventsButton = new javax.swing.JButton();
        eventsTextField = new javax.swing.JTextField();
        addActionsButton = new javax.swing.JButton();
        addConditionsButton = new javax.swing.JButton();
        actionTextField = new javax.swing.JTextField();
        conditionTextField = new javax.swing.JTextField();
        ltlLabel = new javax.swing.JLabel();
        ltlSpecTextField = new javax.swing.JTextField();
        proveButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        StateRB = new javax.swing.JRadioButton();
        macroStateRB = new javax.swing.JRadioButton();
        ElementTextName = new javax.swing.JTextField();
        NameLabel = new javax.swing.JLabel();
        doneMSButton = new javax.swing.JButton();
        EdgeRB = new javax.swing.JRadioButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                formMousePressed(evt);
            }
        });

        STPanel.setBackground(new java.awt.Color(255, 255, 255));
        STPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        STPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                STPanelMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                STPanelMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                STPanelMouseReleased(evt);
            }
        });
        STPanel.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                STPanelMouseMoved(evt);
            }
        });

        javax.swing.GroupLayout STPanelLayout = new javax.swing.GroupLayout(STPanel);
        STPanel.setLayout(STPanelLayout);
        STPanelLayout.setHorizontalGroup(
            STPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 585, Short.MAX_VALUE)
        );
        STPanelLayout.setVerticalGroup(
            STPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 397, Short.MAX_VALUE)
        );

        HeadLabel.setFont(new java.awt.Font("Arial", 1, 14));
        HeadLabel.setText("State Transition Diagram Control Panel");

        InsertGroup.add(modifyRB);
        modifyRB.setSelected(true);
        modifyRB.setText("ModifySTDiagram");
        modifyRB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        modifyRB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        modifyRB.setName("modifyRB");

        jScrollPane1.setViewportView(eventsList);

        jLabel1.setText("Events");

        jLabel2.setText("Actions");

        jScrollPane2.setViewportView(actionsList);

        jLabel3.setText("Conditions");

        jScrollPane3.setViewportView(conditionsList);

        addEventsButton.setText("Add");
        addEventsButton.setActionCommand("AddEvent");
        addEventsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addItemList(evt);
            }
        });

        addActionsButton.setText("Add");
        addActionsButton.setActionCommand("AddAction");
        addActionsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addItemList(evt);
            }
        });

        addConditionsButton.setText("Add");
        addConditionsButton.setActionCommand("AddCondition");
        addConditionsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addItemList(evt);
            }
        });

        ltlLabel.setText("LTL SPEC");

        proveButton.setText("Prove");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("State Management"));
        InsertGroup.add(StateRB);
        StateRB.setText("State");
        StateRB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        StateRB.setMargin(new java.awt.Insets(0, 0, 0, 0));

        InsertGroup.add(macroStateRB);
        macroStateRB.setText("MacroState");
        macroStateRB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        macroStateRB.setMargin(new java.awt.Insets(0, 0, 0, 0));

        NameLabel.setFont(new java.awt.Font("Arial", 0, 12));
        NameLabel.setText("State Name");

        doneMSButton.setText("Done");
        doneMSButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                macroButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(doneMSButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 73, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(StateRB, javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(macroStateRB, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 70, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(ElementTextName, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(NameLabel))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(StateRB)
                    .addComponent(NameLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(macroStateRB)
                    .addComponent(ElementTextName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
                .addComponent(doneMSButton, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        InsertGroup.add(EdgeRB);
        EdgeRB.setText("Transition");
        EdgeRB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        EdgeRB.setMargin(new java.awt.Insets(0, 0, 0, 0));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(HeadLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 293, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(22, 22, 22)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(ltlLabel)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addComponent(proveButton, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(ltlSpecTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 273, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addComponent(EdgeRB))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(STPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(22, 22, 22))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(modifyRB)
                        .addGap(250, 250, 250)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(eventsTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addEventsButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(actionTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addActionsButton))
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(conditionTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addConditionsButton))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(25, 25, 25)
                        .addComponent(HeadLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(37, 37, 37)
                        .addComponent(EdgeRB)
                        .addGap(30, 30, 30)
                        .addComponent(ltlLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(ltlSpecTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(31, 31, 31)
                        .addComponent(proveButton))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(STPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(modifyRB))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(addEventsButton)
                                    .addComponent(eventsTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel2)
                                .addGap(4, 4, 4)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(addActionsButton)
                                    .addComponent(actionTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(addConditionsButton)
                                    .addComponent(conditionTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(27, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents*/

    private void macroButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_macroButtonActionPerformed

        int MIN_X = Integer.MAX_VALUE;
        int MIN_Y = Integer.MAX_VALUE;
        int MAX_X = Integer.MIN_VALUE;
        int MAX_Y = Integer.MIN_VALUE;
        if(evt.getSource().equals(doneMSButton)){
            LinkedList<StateFrame> states = new LinkedList();
            
            for(int i = 0; i < toDraw.size(); i++){
                Object o = toDraw.get(i);
                if(o instanceof StateFrame){
                    StateFrame sf = (StateFrame)o;
                    if(sf.getSelected()){
                        states.add(sf);
                        int minx = sf.getPosition().x;
                        int miny = sf.getPosition().y;
                        int maxx = sf.getPosition().x + sf.getDimension().width;
                        int maxy = sf.getPosition().y + sf.getDimension().height;
                        //System.out.println(maxx + " " + maxy + " " + minx  + " " + miny);
                        if(maxx > MAX_X) MAX_X = maxx;
                        if(maxy > MAX_Y) MAX_Y = maxy;
                        if(minx < MIN_X) MIN_X = minx;
                        if(minx < MIN_Y) MIN_Y = miny;
                        sf.setSelected(false);
                    }
                }
            }
            //System.out.println(MAX_X + " " + MAX_Y + " " + MIN_X  + " " + MIN_Y);
            MacroStateFrame msf = new MacroStateFrame(new Point(MIN_X-5, MIN_Y-5),new Dimension(MAX_X - MIN_X + 10,MAX_Y - MIN_Y + 10),states);
            //StateFrame msf = new StateFrame(new Point(MIN_X-5,MIN_Y-5));
            toDraw.add(msf);
            doneMSButton.setVisible(false);
            repaint();
        }
    }//GEN-LAST:event_macroButtonActionPerformed

    private void addItemList(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addItemList

        if(evt.getActionCommand().equals("AddEvent")){
            String text = eventsTextField.getText();
            if(text != "" && text != null && !text.contains(" ") && !text.equals("null")){
                if(!binder.getHashMap().containsKey(text) && !(dlmEvents.contains(text)) && !(dlmActions.contains(text)) && !(dlmConditions.contains(text))) dlmEvents.add(dlmEvents.size(),text);
                else JOptionPane.showMessageDialog(this,"Il nome scelto non puo' essere assegnato, sceglierne uno non utilizzato per stati,eventi,azioni e condizioni","Errore",JOptionPane.ERROR_MESSAGE);
            } else JOptionPane.showMessageDialog(this,"Il nome scelto non puo' essere assegnato","Errore",JOptionPane.ERROR_MESSAGE);
            
        }
        if(evt.getActionCommand().equals("AddAction")){
            String text = actionTextField.getText();
            if(text != "" && text != null && !text.contains(" ") && !text.equals("null")){
            	if(!binder.getHashMap().containsKey(text) && !(dlmEvents.contains(text)) && !(dlmActions.contains(text)) && !(dlmConditions.contains(text))) dlmActions.add(dlmActions.size(),text);
                else JOptionPane.showMessageDialog(this,"Il nome scelto non puo' essere assegnato, sceglierne uno non utilizzato per stati,eventi,azioni e condizioni","Errore",JOptionPane.ERROR_MESSAGE);
            } else JOptionPane.showMessageDialog(this,"Il nome scelto non puo' essere assegnato","Errore",JOptionPane.ERROR_MESSAGE);
            
        }
        if(evt.getActionCommand().equals("AddCondition")){
            String text = conditionTextField.getText();
            if(text != "" && text != null && !text.contains(" ") && !text.equals("null")){
            	if(!binder.getHashMap().containsKey(text) && !(dlmEvents.contains(text)) && !(dlmActions.contains(text)) && !(dlmConditions.contains(text))) dlmConditions.add(dlmConditions.size(),text);
                else JOptionPane.showMessageDialog(this,"Il nome scelto non puo' essere assegnato, sceglierne uno non utilizzato per stati, eventi,azioni e condizioni","Errore",JOptionPane.ERROR_MESSAGE);
            } else JOptionPane.showMessageDialog(this,"Il nome scelto non puo' essere assegnato","Errore",JOptionPane.ERROR_MESSAGE);
            
        }
    }//GEN-LAST:event_addItemList
    
    public LinkedList getFigure(){
        return toDraw;
    }
    
    private void STPanelMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_STPanelMouseReleased

    }//GEN-LAST:event_STPanelMouseReleased

    private void STPanelMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_STPanelMousePressed
        boolean again = true;
        xPressed = evt.getX();
        yPressed = evt.getY();
        
        if(macroStateRB.isSelected()){
             doneMSButton.setVisible(true);
             for(int j = 0;j < toDraw.size();j++) { 
                Object o = toDraw.get(j);
                if(o instanceof StateFrame){
                    StateFrame sf = (StateFrame) o;
                    Point p = sf.getPosition();
                    Dimension d = sf.getDimension();
                     if(xPressed >= p.x && xPressed <= p.x + d.width && yPressed >= p.y && yPressed <= p.y + d.height){
                     if(!sf.getSelected()) sf.setSelected(true); 
                     else sf.setSelected(false);
                    }
                }
            }
        }
        if(modifyRB.isSelected()){

            for(int j = 0;j < toDraw.size();j++) {
                
                Object o = toDraw.get(j);
                if(o instanceof Figure){
                Figure f = (Figure)o;
                if(again){ // again serve per limitare la selezione ad una sola figura per volta
                Point p = f.getPosition();
                Dimension d = f.getDimension();
                
                if(f instanceof StateFrame){
                    StateFrame sf = (StateFrame)f;
                    Rectangle2D r = sf.getRectangle();
                    if(xPressed >= p.x && xPressed <= p.x + d.width && yPressed >= p.y && yPressed <= p.y + d.height){
                        if(!sf.getSelected()){
                        sf.setSelected(true);
                        modify.show(evt.getComponent(),evt.getX(),evt.getY());
                        } else sf.setSelected(false);
                        again = false;
                    }
                }
                

            }
            }  
                
                
                else if(o instanceof EdgeLoop){
            	EdgeLoop e = (EdgeLoop)o;
            	if(again){
            		if(e.isNear(evt.getPoint())){
            			if(!e.getSelected()) {
            				e.setSelected(true);
                			deleteEdge.show(evt.getComponent(),evt.getX(),evt.getY());
                			again = false;
            			}
            		}
            			else e.setSelected(false);
            			
            		}
            	}
            
                
                else if (o instanceof EdgeST) {
            	
            	
	            EdgeST e = (EdgeST)o;
	            e.setSelected(false);
	            if(again){	
	            	Point start = e.getStartPoint();
	            	Point end = e.getEndPoint();
	            	if(((evt.getX() > start.x && evt.getX() < end.x) || (evt.getX() > end.x && evt.getX() < start.x))  &&  ((evt.getY() > start.y && evt.getY() < end.y) || (evt.getY() > end.y && evt.getY() < start.y))){
            	
	            		double coeffAng = (double)(end.y - start.y) / (double)(end.x - start.x);
	            		double noteTerm = start.y - coeffAng*start.x;
	            		double result = evt.getY() - coeffAng*evt.getX() - noteTerm;
                
	            		if(Math.abs(result) <= 50) {
	            			if(!e.getSelected()) {
	            				e.setSelected(true);
	            				deleteEdge.show(evt.getComponent(),evt.getX(),evt.getY());
	            				again = false;
	            			}
	            			else {
	            				e.setSelected(false);
	            				again = false;
	            			}
	            		} 
	            	} 
	            	
	            }
	            
	            }
	            }
	        repaint();
	        }
	    }//GEN-LAST:event_STPanelMousePressed

    private void formMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMousePressed

    }//GEN-LAST:event_formMousePressed


    public void paint(Graphics g) {
        
        
        
        super.paint(g);
        Graphics2D g2 =  (Graphics2D)STPanel.getGraphics();
        
        for(int k = 0;k < toDraw.size();k++){
            if(toDraw.get(k) instanceof EdgeST){
                EdgeST e = (EdgeST)toDraw.get(k);
                for(int z = k+1;z < toDraw.size();z++){
                    if(toDraw.get(z) instanceof EdgeST){
                        EdgeST edge = (EdgeST)toDraw.get(z);
                        if(e.cover(edge)){
                            if(e instanceof EdgeLoop){
                                e.setStartPoint(new Point(e.getStartPoint().x+25,e.getStartPoint().y));
                                e.setEndPoint(new Point(e.getEndPoint().x+25,e.getEndPoint().y));
                                edge.setStartPoint(new Point(edge.getStartPoint().x-25,edge.getStartPoint().y));
                                edge.setEndPoint(new Point(edge.getEndPoint().x-25,edge.getEndPoint().y));
                            } else {
                            if(e instanceof EdgeST){
                                Point p = ((StateFrame)e.getTail()).getCG();
                                Dimension d = ((StateFrame)e.getTail()).getDimension();
                                Point start = new Point(p.x + d.width/4,p.y + d.height/4);
                                //System.out.println(start.x + " " + start.y);
                                Point p2 = ((StateFrame)e.getHead()).getCG();
                                Dimension d2 = ((StateFrame)e.getHead()).getDimension();
                                Point end = new Point(p2.x + d2.width/4,p2.y + d2.height/4);
                                //System.out.println(end.x + " " + end.y);
                                EdgeST eNew = new EdgeST(e.getTail(),e.getHead(),new Line2D.Double(start,end),e.getName());
                                e.setStartPoint(eNew.getStartPoint());
                                e.setEndPoint(eNew.getEndPoint());
                            }
                            if(edge instanceof EdgeST){
                                Point p = ((StateFrame)edge.getTail()).getCG();
                                Dimension d = ((StateFrame)edge.getTail()).getDimension();
                                Point start = new Point(p.x - d.width/4,p.y - d.height/4);
                                //System.out.println(start.x + " " + start.y);
                                Point p2 = ((StateFrame)edge.getHead()).getCG();
                                Dimension d2 = ((StateFrame)edge.getHead()).getDimension();
                                Point end = new Point(p2.x - d2.width/4,p2.y - d2.height/4);
                                //System.out.println(end.x + " " + end.y);
                                EdgeST eNew = new EdgeST(edge.getTail(),edge.getHead(),new Line2D.Double(start,end),edge.getName());
                                edge.setStartPoint(eNew.getStartPoint());
                                edge.setEndPoint(eNew.getEndPoint());
                            }
                            }

                        }
                    }
                }
            }
        }
        
        for(int j = 0; j < toDraw.size(); j++){
            
            if(toDraw.get(j) instanceof Figure){
            Figure f = (Figure)toDraw.get(j);
            f.draw(g2);
            } else 
                if(toDraw.get(j) instanceof EdgeLoop){
                    EdgeLoop el = (EdgeLoop)toDraw.get(j);
                    el.draw(g2);
            } else {
                EdgeST f = (EdgeST)toDraw.get(j);
                f.draw(g2);
            }
            
       }
        
        if (drawing && EdgeRB.isSelected()) {
            g2.setColor(Color.RED);
            g2.drawLine(xIniz, yIniz, xFin, yFin);
            }
        
        if(moving) {
            g2.setColor(Color.YELLOW);
            for(int i = 0; i < toDraw.size(); i++){
            Object o = toDraw.get(i);
            if(o instanceof StateFrame){
            StateFrame sf = (StateFrame)o;
            if(sf.getSelected()){
                    Dimension d = sf.getDimension();
                    g2.drawRect(xFin,yFin,d.width,d.height);
                    g2.setColor(Color.LIGHT_GRAY);
                    g2.fillRect(xFin,yFin,d.width,d.height);
                
            }
            }
        }
    }
    }
    
    private void STPanelMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_STPanelMouseMoved

        xFin = evt.getX();
        yFin = evt.getY();
        
        if((moving && modifyRB.isSelected()) || (drawing && (EdgeRB.isSelected() || macroStateRB.isSelected()))){
            repaint();   
        }
    }//GEN-LAST:event_STPanelMouseMoved

    private void STPanelMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_STPanelMouseClicked
        
        if(!drawing && !moving) {
            xIniz = evt.getX();
            yIniz = evt.getY();
        } else {
            xFin = evt.getX();
            yFin = evt.getY();
        }
        
       
        
        if(StateRB.isSelected()){
        	if(ElementTextName.getText().length() != 0 && !(ElementTextName.getText().contains(" ")) && !(ElementTextName.getText().equals("null"))){
        	if(!this.binder.getHashMap().containsKey(ElementTextName.getText()) && !dlmEvents.contains(ElementTextName.getText()) && !dlmActions.contains(ElementTextName.getText()) && !dlmConditions.contains(ElementTextName.getText())){
            
        		StateFrame frame = new StateFrame(new Point(xIniz,yIniz));
        		if(this.binder.getHashMap().isEmpty()){
	            	frame.setInitial();
	            }
	            Label label = new Label(ElementTextName.getText());
	            label.setFont(new Font("Sans Serif", Font.BOLD, 12));
	            label.setTextAlignment(Label.ALIGNMENT_CENTER);
	            frame.getFigure().add(label);
	            
	            toDraw.add(frame);
	            
            //binder
            
	            binder.createState(ElementTextName.getText());

	            if(frame.isInitial()) binder.setInitState(ElementTextName.getText());
	            
        	} else JOptionPane.showMessageDialog(this,"Scegliere un nome diverso per ogni stato, evento, azione e condizione","Errore",JOptionPane.ERROR_MESSAGE);
        
//        } else if(macroStateRB.isSelected() && !drawing){
//            drawing = true;
//        
//        } else if(macroStateRB.isSelected() && drawing) {
//            drawing = false;
        } else JOptionPane.showMessageDialog(this,"E' obbligatorio specificare un nome per ogni stato che non contenga spazi","Errore",JOptionPane.ERROR_MESSAGE);
            
        } else if (!drawing && EdgeRB.isSelected()) {
            drawing = true;
            
            
        } else if (drawing && EdgeRB.isSelected()){ // AGGIUNTA TRANSIZIONE
            drawing = false;
            boolean tailIn = false;
            boolean headIn = false;
            Figure tail = new Figure();
            Figure head = new Figure();
            for(int i = 0; i < toDraw.size(); i++){
               Object o = toDraw.get(i);
               if(o instanceof StateFrame){
                   StateFrame f = (StateFrame)o;
                   Point p = f.getPosition();
                   Dimension d = f.getDimension();
                   Rectangle2D r = new Rectangle2D.Double(p.x,p.y,d.width,d.height);
                   
                   if(r.contains(new Point2D.Double(xIniz,yIniz))) {
                       tail = f;
                       tailIn = true;
                   }
                   
                   if(r.contains(new Point2D.Double(xFin,yFin))) {
                       head = f;
                       headIn = true;
                   }
               
                } 
                }
            
                if(tailIn && headIn){
                String event, action, condition = "";
                event = (String)eventsList.getSelectedValue();
                action = (String)actionsList.getSelectedValue();
                condition = (String)conditionsList.getSelectedValue();
                eventsList.setModel(dlmEvents);
                actionsList.setModel(dlmActions);
                conditionsList.setModel(dlmConditions);
                String result = "";
                if(event != null) result = event;
                if(action != null) result = event + " / " + action;
                if(condition!= null && action ==null) result = event + " ["+ condition+".]";
                if(condition != null && action != null) result = event +  " [" + condition + ".]" + " / " + action;
                if(result != "" && event != null){
                    //if(!binder.getHashMap().containsKey(((Label)((StateFrame)tail).getFigure().get(0)).getText() + ((Label)((StateFrame)head).getFigure().get(0)).getText() + event)){
                	String key = null;
                	if(condition==null){
                		key = ((Label)((StateFrame)tail).getFigure().get(0)).getText() + event;
                	}else{
                		key = ((Label)((StateFrame)tail).getFigure().get(0)).getText() + event + condition;
                	}
                	if(!binder.getHashMap().containsKey(key)){
                	if(tail == head){
                        EdgeLoop loop = new EdgeLoop(tail,result);
                        loop.setLabelName(result);
                        loop.setStyle(Edge.STYLE_HAS);
                        toDraw.add(loop);
                        ((StateFrame)tail).addTailEdge(loop);
                        
                        //binder
                        
                        binder.createTransition(((Label)((StateFrame)tail).getFigure().get(0)).getText(),
        						((Label)((StateFrame)tail).getFigure().get(0)).getText(),
        		                 event,action,condition);
                    } else {
                    EdgeST edge = new EdgeST(tail,head,new Line2D.Double(xIniz,yIniz,xFin,yFin),result);
                    edge.setLabelName(result);
                    edge.setStyle(Edge.STYLE_HAS);
                    toDraw.add(edge);
                    ((StateFrame)tail).addTailEdge(edge);
                    ((StateFrame)head).addHeadEdge(edge);
                    
                    //binder
                    
                    binder.createTransition(((Label)((StateFrame)tail).getFigure().get(0)).getText(),
                    						((Label)((StateFrame)head).getFigure().get(0)).getText(),
                    		                 event,action,condition);
                    
                }
                } else JOptionPane.showMessageDialog(this,"Transizione esistente o inconsistente con il resto del diagramma","Errore",JOptionPane.ERROR_MESSAGE);
                    
                } else JOptionPane.showMessageDialog(this,"Inserire una transizione con un evento associato","Errore",JOptionPane.ERROR_MESSAGE);
              }
            
            } else if(moving && modifyRB.isSelected()){
            moving = false;
                 for(int i = 0; i < toDraw.size(); i++){
                    Object o = toDraw.get(i);
                    if(o instanceof Figure){   
                        if(((Figure)o).getSelected()) {
                        ((Figure)o).setSelected(false);
                        if(o instanceof StateFrame){
                            StateFrame sf = (StateFrame)o;
                            toDraw.remove(sf);
                            sf.setPosition(new Point(xFin,yFin),toDraw);
                            toDraw.add(sf);
                        }

                    }
                 }
            }
            }
        
       repaint();
    }//GEN-LAST:event_STPanelMouseClicked
    
    /**
     * @param args the command line arguments
     */
 /*   public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ControlPanel().setVisible(true);
            }
        });
    }*/
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton EdgeRB;
    private javax.swing.JTextField ElementTextName;
    private javax.swing.JLabel HeadLabel;
    private javax.swing.ButtonGroup InsertGroup;
    private javax.swing.JLabel NameLabel;
    javax.swing.JPanel STPanel;
    private javax.swing.JRadioButton StateRB;
    private javax.swing.JTextField actionTextField;
    private javax.swing.JList actionsList;
    private javax.swing.JButton addActionsButton;
    private javax.swing.JButton addConditionsButton;
    private javax.swing.JButton addEventsButton;
    private javax.swing.JTextField conditionTextField;
    private javax.swing.JList conditionsList;
    private javax.swing.JButton doneMSButton;
    private javax.swing.JList eventsList;
    private javax.swing.JTextField eventsTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JLabel ltlLabel;
    protected javax.swing.JTextField ltlSpecTextField;
    private javax.swing.JRadioButton macroStateRB;
    private javax.swing.JRadioButton modifyRB;
    private javax.swing.JButton proveButton;
    // End of variables declaration//GEN-END:variables
    
}
